## python-pyftpdlib 1.5.1

=== Makefile ===
# Shortcuts for various tasks (UNIX only).
# To use a specific Python version run:
# $ make install PYTHON=python3.3

PYTHON=python
TSCRIPT=pyftpdlib/test/runner.py
FLAGS=

all: test

clean:
	rm -f `find . -type f -name \*.py[co]`
	rm -f `find . -type f -name .\*~`
	rm -f `find . -type f -name \*.orig`
	rm -f `find . -type f -name \*.bak`
	rm -f `find . -type f -name \*.rej`
	rm -rf `find . -type d -name __pycache__`
	rm -rf *.egg-info
	rm -rf .tox
	rm -rf build
	rm -rf dist
	rm -rf docs/_build

build: clean
	$(PYTHON) setup.py build

install: build
	$(PYTHON) setup.py install --user;

uninstall:
	pip-`$(PYTHON) -c "import sys; sys.stdout.write('.'.join(list(map(str, sys.version_info))[:2]))"` uninstall -y -v pyftpdlib

# useful deps which are nice to have while developing / testing
setup-dev-env: install-git-hooks
	python -c  "import urllib2, ssl; \
				context = ssl._create_unverified_context() if hasattr(ssl, '_create_unverified_context') else None; \
				kw = dict(context=context) if context else {}; \
				r = urllib2.urlopen('https://bootstrap.pypa.io/get-pip.py', **kw); \
				open('/tmp/get-pip.py', 'w').write(r.read());"
	$(PYTHON) /tmp/get-pip.py --user
	rm /tmp/get-pip.py
	$(PYTHON) -m pip install --user --upgrade pip
	$(PYTHON) -m pip install --user --upgrade \
		coverage  \
		flake8 \
		ipdb \
		mock==1.0.1 \
		nose \
		pep8 \
		pyflakes \
		pyopenssl \
		pysendfile \
		sphinx \
		sphinx-pypi-upload \
		unittest2 \

test: install
	$(PYTHON) $(TSCRIPT)

test-functional: install
	$(PYTHON) pyftpdlib/test/test_functional.py

test-functional-ssl: install
	$(PYTHON) pyftpdlib/test/test_functional_ssl.py

# Run a specific test by name; e.g. "make test-by-name retr" will run
# all test methods containing "retr" in their name.
# Requires "pip install nose".
test-by-name:
	@$(PYTHON) -m nose pyftpdlib/test/test_*.py --nocapture -v -m $(filter-out $@,$(MAKECMDGOALS))

nosetest: install
	# $ make nosetest FLAGS=test_name
	nosetests $(TSCRIPT) -v -m $(FLAGS)

pep8:
	pep8 pyftpdlib/ demo/ test/ setup.py --ignore E302

pyflakes:
	# ignore doctests
	export PYFLAKES_NODOCTEST=1 && \
		pyflakes pyftpdlib/ demo/ test/ setup.py

flake8:
	@git ls-files | grep \\.py$ | xargs flake8

upload-src: clean
	$(PYTHON) setup.py sdist upload

# Build and upload doc on https://pythonhosted.org/pyftpdlib/.
# Requires "pip install sphinx-pypi-upload".
upload-docs:
	cd docs; make html
	$(PYTHON) setup.py upload_sphinx --upload-dir=docs/_build/html

# git-tag a new release
git-tag-release:
	git tag -a release-`python -c "import setup; print(setup.VERSION)"` -m `git rev-list HEAD --count`:`git rev-parse --short HEAD`
	@echo "now run 'git push --tags'"

# install GIT pre-commit hook
install-git-hooks:
	ln -sf ../../.git-pre-commit .git/hooks/pre-commit
	chmod +x .git/hooks/pre-commit

## python-pyftpdlib 0.5.2

=== debian/changelog ===
python-pyftpdlib (0.5.2-1) unstable; urgency=low

  * Initial release. (Closes: #528602)

 -- Janos Guljas <janos@janos.in.rs>  Sun, 20 Jun 2010 22:31:55 +0200

=== debian/control ===
Source: python-pyftpdlib
Section: python
Priority: optional
Maintainer: Janos Guljas <janos@janos.in.rs>
Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends: debhelper (>= 7.0.50), python (>= 2.5), python-support (>= 0.8.4)
XS-Python-Version: >= 2.5
Standards-Version: 3.8.4
Homepage: http://code.google.com/p/pyftpdlib/
Vcs-Svn: svn://svn.debian.org/python-modules/packages/python-pyftpdlib/trunk
Vcs-Browser: http://svn.debian.org/viewsvn/python-modules/packages/python-pyftpdlib/trunk/

Package: python-pyftpdlib
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
XB-Python-Version: ${python:Versions}
Provides: ${python:Provides}
Description: Python FTP server library
 Python FTP server library provides a high-level portable interface to
 easily write asynchronous FTP servers with Python.
 .
 pyftpdlib is currently the most complete RFC-959 FTP server
 implementation available for Python programming language. It is used
 in projects like Google Chromium and Bazaar.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_test:
	PYTHONPATH=. python test/test_ftpd.py

## python-pyftpdlib 0.6.0

=== debian/changelog ===
python-pyftpdlib (0.6.0-1) unstable; urgency=low

  [ Janos Guljas ]
  * New upstream release.
  * Changed my email address to janos@resenje.org.
  * Bump standards to 3.9.2. No changes needed.
  * Updated debian/copyright to DEP5 format.
  * Switch to dh_python2.

  [ Jan Dittberner ]
  * depend on python (>= 2.6.6-3~) instead of python-all (>= 2.5)

 -- Janos Guljas <janos@resenje.org>  Fri, 27 May 2011 17:50:09 +0200

=== debian/control ===
Source: python-pyftpdlib
Section: python
Priority: optional
Maintainer: Janos Guljas <janos@resenje.org>
Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends: debhelper (>= 7.0.50~), python (>= 2.6.6-3~)
Standards-Version: 3.9.2
Homepage: http://code.google.com/p/pyftpdlib/
Vcs-Svn: svn://svn.debian.org/python-modules/packages/python-pyftpdlib/trunk
Vcs-Browser: http://svn.debian.org/viewsvn/python-modules/packages/python-pyftpdlib/trunk/

Package: python-pyftpdlib
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Provides: ${python:Provides}
Description: Python FTP server library
 Python FTP server library provides a high-level portable interface to
 easily write asynchronous FTP servers with Python.
 .
 pyftpdlib is currently the most complete RFC-959 FTP server
 implementation available for Python programming language. It is used
 in projects like Google Chromium and Bazaar.

## python-pyftpdlib 0.7.0

=== debian/changelog ===
python-pyftpdlib (0.7.0-1) unstable; urgency=low

  * New upstream release.
  * Remove doc directory from debian/docs and debian/doc-base file 
    as upstream removed documentation.
  * Update years debian/copyright.
  * Add debian/local-options.

 -- Janos Guljas <janos@resenje.org>  Thu, 26 Jan 2012 04:02:09 +0100

python-pyftpdlib (0.6.0-2) unstable; urgency=low

  * Add DM-Upload-Allowed control field.
  * Fix dep5 syntax.

 -- Janos Guljas <janos@resenje.org>  Sun, 11 Dec 2011 15:47:48 +0100

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Janos Guljas <janos@resenje.org>
 Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
+DM-Upload-Allowed: yes
 Build-Depends: debhelper (>= 7.0.50~), python (>= 2.6.6-3~)
 Standards-Version: 3.9.2
 Homepage: http://code.google.com/p/pyftpdlib/

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh --with python2 $@

override_dh_auto_test:
	PYTHONPATH=. python test/test_ftpd.py

## python-pyftpdlib 1.2.0

=== debian/changelog ===
python-pyftpdlib (1.2.0-1) unstable; urgency=low

  [ Jakub Wilk ]
  * Use canonical URIs for Vcs-* fields.
  * Remove DM-Upload-Allowed; it's no longer used by the archive
    software.
  * Run tests only if DEB_BUILD_OPTIONS=nocheck is not set.

  [ Janos Guljas ]
  * New upstream release. (Closes: #717946)
  * Recommends and Build-Depend (for tests) on python-sendfile.
  * Raise debhelper compatiblility to 9.
  * Raise Standards-Version to 3.9.4.
  * Update copyright years in debian/copyright.
  * Update Format link in debian/copyright.
  * Change my email address.

 -- Janos Guljas <janos@debian.org>  Fri, 02 Aug 2013 02:25:28 +0200

=== debian/control ===
Source: python-pyftpdlib
Section: python
Priority: optional
Maintainer: Janos Guljas <janos@debian.org>
Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends: debhelper (>= 9), python (>= 2.6.6-3~), python-sendfile
Standards-Version: 3.9.4
Homepage: http://code.google.com/p/pyftpdlib/
Vcs-Svn: svn://anonscm.debian.org/python-modules/packages/python-pyftpdlib/trunk/
Vcs-Browser: http://anonscm.debian.org/viewvc/python-modules/packages/python-pyftpdlib/trunk/

Package: python-pyftpdlib
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Recommends: python-sendfile
Provides: ${python:Provides}
Description: Python FTP server library
 Python FTP server library provides a high-level portable interface to
 easily write asynchronous FTP servers with Python.
 .
 pyftpdlib is currently the most complete RFC-959 FTP server
 implementation available for Python programming language. It is used
 in projects like Google Chromium and Bazaar.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with python2

override_dh_auto_test:
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	PYTHONPATH=. python test/test_ftpd.py
endif

=== debian/watch ===
version=3
http://code.google.com/p/pyftpdlib/  http://pyftpdlib.googlecode.com/files/pyftpdlib-(.*).tar.gz

## python-pyftpdlib 1.4.0

=== debian/changelog ===
python-pyftpdlib (1.4.0-1) unstable; urgency=low

  [ W. Martin Borgert ]
  * Add Python 3 package. (Closes: #782512)
  * Change homepage from Google code to GitHub. (Closes: #782514)
  * Add myself to Uploaders.
  * New upstream version. (Closes: #794188)

  [ Janos Guljas, 2013-08-15 ]
  * Depend and Build-Depend on python-sendfile >= 2.0.0. (Closes: #718576)

 -- W. Martin Borgert <debacle@debian.org>  Sun, 22 Nov 2015 16:54:04 +0000

=== debian/control ===
Source: python-pyftpdlib
Section: python
Priority: optional
Maintainer: Janos Guljas <janos@debian.org>
Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>,
           W. Martin Borgert <debacle@debian.org>
Build-Depends: debhelper (>= 9),
               python-all (>= 2.6.6-3~),
               python-sendfile (>= 2.0.0),
               python3-sendfile (>= 2.0.0),
               python-setuptools (>= 0.6b3),
               python3-all,
               python3-setuptools,
               dh-python
Standards-Version: 3.9.6
Homepage: https://github.com/giampaolo/pyftpdlib/
Vcs-Git: git://anonscm.debian.org/python-modules/packages/python-pyftpdlib.git
Vcs-Browser: https://anonscm.debian.org/cgit/python-modules/packages/python-pyftpdlib.git

Package: python-pyftpdlib
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Recommends: python-sendfile (>= 2.0.0)
Provides: ${python:Provides}
Description: Python FTP server library
 Python FTP server library provides a high-level portable interface to
 easily write asynchronous FTP servers with Python.
 .
 pyftpdlib is currently the most complete RFC-959 FTP server
 implementation available for Python programming language. It is used
 in projects like Google Chromium and Bazaar.
 .
 This package provides the Python 2.x module.

Package: python3-pyftpdlib
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Recommends: python3-sendfile (>= 2.0.0)
Provides: ${python3:Provides}
Description: Python FTP server library
 Python FTP server library provides a high-level portable interface to
 easily write asynchronous FTP servers with Python.
 .
 pyftpdlib is currently the most complete RFC-959 FTP server
 implementation available for Python programming language. It is used
 in projects like Google Chromium and Bazaar.
 .
 This package provides the Python 3.x module.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=pyftpdlib

%:
	dh $@ --with python2,python3 --buildsystem=pybuild

override_dh_auto_test:
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	PYTHONPATH=. python test/test_ftpd.py
endif

## python-pyftpdlib 1.5.1

=== debian/changelog ===
python-pyftpdlib (1.5.1-4ubuntu1) artful; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Increase test timeout limit on buildds so that tests wont error out
      (Fix FTBFS on amd64).
    + Keep the above change as disabling unstable tests wont suffice on
      ubuntu buildds.  

 -- Bhavani Shankar <bhavi@ubuntu.com>  Thu, 01 Jun 2017 15:10:00 +0530

python-pyftpdlib (1.5.1-4) unstable; urgency=medium

  * Disable automatic tests, that are known to be unstable (Closes: #856335)
  * Remove Janos Guljas as maintainer (Closes: #849728)

 -- W. Martin Borgert <debacle@debian.org>  Sat, 22 Apr 2017 22:45:44 +0000

python-pyftpdlib (1.5.1-3ubuntu1) zesty; urgency=medium

  * Increase test timeout limit on buildds so that tests wont error out
    (Fix FTBFS on amd64).

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sat, 11 Feb 2017 11:21:24 +0530

python-pyftpdlib (1.5.1-3) unstable; urgency=medium

  * Set TRAVIS=1 to skip one unit test, marked by upstream as
    "failing on Travis" (Closes: #842007)

 -- W. Martin Borgert <debacle@debian.org>  Sun, 25 Dec 2016 20:40:48 +0000

python-pyftpdlib (1.5.1-2) unstable; urgency=medium

  * Build-Depend on python{,3}-openssl/python3-openssl and python{,3}-mock.
  * Run tests from source dir. (Closes: #841079) hopefully

 -- W. Martin Borgert <debacle@debian.org>  Tue, 18 Oct 2016 00:55:20 +0000

python-pyftpdlib (1.5.1-1) unstable; urgency=medium

  * New upstream release. (Closes: #833454)
  [ Ondřej Nový 2016-03-29 ]
  * Fixed VCS URL (https)

 -- W. Martin Borgert <debacle@debian.org>  Mon, 10 Oct 2016 23:33:12 +0000

=== debian/control ===
--- 
+++ 
@@ -1,20 +1,24 @@
 Source: python-pyftpdlib
 Section: python
 Priority: optional
-Maintainer: Janos Guljas <janos@debian.org>
-Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>,
-           W. Martin Borgert <debacle@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>,
+Uploaders: W. Martin Borgert <debacle@debian.org>
 Build-Depends: debhelper (>= 9),
                python-all (>= 2.6.6-3~),
+               python-mock,
+               python3-mock,
+               python-openssl,
+               python3-openssl,
                python-sendfile (>= 2.0.0),
                python3-sendfile (>= 2.0.0),
                python-setuptools (>= 0.6b3),
                python3-all,
                python3-setuptools,
                dh-python
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/giampaolo/pyftpdlib/
-Vcs-Git: git://anonscm.debian.org/python-modules/packages/python-pyftpdlib.git
+Vcs-Git: https://anonscm.debian.org/git/python-modules/packages/python-pyftpdlib.git
 Vcs-Browser: https://anonscm.debian.org/cgit/python-modules/packages/python-pyftpdlib.git
 
 Package: python-pyftpdlib

=== debian/rules ===
--- 
+++ 
@@ -7,5 +7,18 @@
 
 override_dh_auto_test:
 ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
-	PYTHONPATH=. python test/test_ftpd.py
+	EXCLUDETESTS="test_functional.py test_functional_ssl.py" \
+	PYTHONPATH=. TRAVIS=1 python pyftpdlib/test/runner.py
+	EXCLUDETESTS="test_functional.py test_functional_ssl.py" \
+	PYTHONPATH=. TRAVIS=1 python3 pyftpdlib/test/runner.py
 endif
+
+override_dh_python2:
+	dh_python2 -O--buildsystem=pybuild
+	rm -f ./debian/python-pyftpdlib/usr/bin/ftpbench \
+	rm -rf ./debian/python-pyftpdlib/usr/lib/python2.7/dist-packages/pyftpdlib/test/
+
+override_dh_python3:
+	dh_python3 -O--buildsystem=pybuild
+	rm -f ./debian/python3-pyftpdlib/usr/bin/ftpbench
+	rm -rf ./debian/python3-pyftpdlib/usr/lib/python3/dist-packages/pyftpdlib/test/

## python-pyftpdlib 1.5.3

=== debian/changelog ===
python-pyftpdlib (1.5.3-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Set Vcs-* to salsa.debian.org
  * d/copyright: Use https protocol in Format field

  [ W. Martin Borgert ]
  * New upstream version
  * Bump standards and dh compat
  * Remove obsolete patch
  * Add -doc package

 -- W. Martin Borgert <debacle@debian.org>  Sat, 10 Mar 2018 14:38:48 +0000

=== debian/control ===
Source: python-pyftpdlib
Section: python
Priority: optional
Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Uploaders: W. Martin Borgert <debacle@debian.org>
Build-Depends: debhelper (>= 11),
               dh-python,
               python-all (>= 2.6.6-3~),
               python3-all,
               python-mock,
               python3-mock,
               python-openssl,
               python3-openssl,
               python-sendfile (>= 2.0.0),
               python3-sendfile (>= 2.0.0),
               python-setuptools (>= 0.6b3),
               python3-setuptools,
	       python3-sphinx,
	       python3-sphinx-rtd-theme
Standards-Version: 4.1.3
Rules-Requires-Root: no
Homepage: https://github.com/giampaolo/pyftpdlib/
Vcs-Git: https://salsa.debian.org/python-team/modules/python-pyftpdlib.git
Vcs-Browser: https://salsa.debian.org/python-team/modules/python-pyftpdlib

Package: python-pyftpdlib
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}
Recommends: python-sendfile (>= 2.0.0)
Provides: ${python:Provides}
Description: Python FTP server library (Python 2)
 Python FTP server library provides a high-level portable interface to
 easily write asynchronous FTP servers with Python.
 .
 pyftpdlib is currently the most complete RFC-959 FTP server
 implementation available for Python programming language. It is used
 in projects like Google Chromium and Bazaar.
 .
 This package provides the Python 2.x module.

Package: python3-pyftpdlib
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}
Recommends: python3-sendfile (>= 2.0.0)
Provides: ${python3:Provides}
Description: Python FTP server library (Python 3)
 Python FTP server library provides a high-level portable interface to
 easily write asynchronous FTP servers with Python.
 .
 pyftpdlib is currently the most complete RFC-959 FTP server
 implementation available for Python programming language. It is used
 in projects like Google Chromium and Bazaar.
 .
 This package provides the Python 3.x module.

Package: python-pyftpdlib-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery,
	${misc:Depends},
	${sphinxdoc:Depends}
Description: documentation for Python FTP server library
 Python FTP server library provides a high-level portable interface to
 easily write asynchronous FTP servers with Python.
 .
 pyftpdlib is currently the most complete RFC-959 FTP server
 implementation available for Python programming language. It is used
 in projects like Google Chromium and Bazaar.
 .
 This package provides the documentation.

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,7 @@
 export PYBUILD_NAME=pyftpdlib
 
 %:
-	dh $@ --with python2,python3 --buildsystem=pybuild
+	dh $@ --with python2,python3,sphinxdoc --buildsystem=pybuild
 
 override_dh_auto_test:
 ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
@@ -22,3 +22,8 @@
 	dh_python3 -O--buildsystem=pybuild
 	rm -f ./debian/python3-pyftpdlib/usr/bin/ftpbench
 	rm -rf ./debian/python3-pyftpdlib/usr/lib/python3/dist-packages/pyftpdlib/test/
+
+override_dh_auto_build:
+	dh_auto_build
+	( cd docs; \
+	  PYTHONPATH=. http_proxy='127.0.0.1:9' sphinx-build -M html . _build )

## python-pyftpdlib 1.5.4

=== Makefile ===
# Shortcuts for various tasks (UNIX only).
# To use a specific Python version run:
# $ make install PYTHON=python3.3

PYTHON = python
TSCRIPT = pyftpdlib/test/runner.py
ARGS =
DEV_DEPS = \
	check-manifest \
	coverage \
	flake8 \
	mock==1.0.1 \
	pep8 \
	pyflakes \
	setuptools \
	sphinx
TEST_DEPS = \
	nose \
	psutil \
	pyopenssl \
	pysendfile \
	unittest2

# In not in a virtualenv, add --user options for install commands.
INSTALL_OPTS = `$(PYTHON) -c "import sys; print('' if hasattr(sys, 'real_prefix') else '--user')"`

all: test

clean:  ## Remove all build files.
	rm -rf `find . -type d -name __pycache__ \
		-o -type f -name \*.bak \
		-o -type f -name \*.orig \
		-o -type f -name \*.pyc \
		-o -type f -name \*.pyd \
		-o -type f -name \*.pyo \
		-o -type f -name \*.rej \
		-o -type f -name \*.so \
		-o -type f -name \*.~ \
		-o -type f -name \*\$testfn`
	rm -rf \
		*.core \
		*.egg-info \
		*\$testfile* \
		.coverage \
		.tox \
		build/ \
		dist/ \
		docs/_build/ \
		htmlcov/ \
		tmp/

install:  ## Install this package.
	# make sure setuptools is installed (needed for 'develop' / edit mode)
	$(PYTHON) -c "import setuptools"
	$(PYTHON) setup.py develop $(INSTALL_OPTS)

uninstall:  ## Uninstall this package.
	cd ..; $(PYTHON) -m pip uninstall -y -v pyftpdlib || true
	$(PYTHON) scripts/purge_installation.py

install-pip:  ## (only if necessary)
	$(PYTHON) -c \
		"import sys, ssl, os, pkgutil, tempfile, atexit; \
		sys.exit(0) if pkgutil.find_loader('pip') else None; \
		pyexc = 'from urllib.request import urlopen' if sys.version_info[0] == 3 else 'from urllib2 import urlopen'; \
		exec(pyexc); \
		ctx = ssl._create_unverified_context() if hasattr(ssl, '_create_unverified_context') else None; \
		kw = dict(context=ctx) if ctx else {}; \
		req = urlopen('https://bootstrap.pypa.io/get-pip.py', **kw); \
		data = req.read(); \
		f = tempfile.NamedTemporaryFile(suffix='.py'); \
		atexit.register(f.close); \
		f.write(data); \
		f.flush(); \
		print('downloaded %s' % f.name); \
		code = os.system('%s %s --user' % (sys.executable, f.name)); \
		f.close(); \
		sys.exit(code);"

setup-dev-env:  ## Install GIT hooks, pip, test deps (also upgrades them).
	${MAKE} install-git-hooks
	${MAKE} install-pip
	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade pip
	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade $(TEST_DEPS)
	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade $(DEV_DEPS)

test:  ## Run all tests.
	${MAKE} install
	PYTHONWARNINGS=all $(PYTHON) $(TSCRIPT)

test-functional:  ## Run functional FTP tests.
	${MAKE} install
	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_functional.py

test-functional-ssl:  ## Run functional FTPS tests.
	${MAKE} install
	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_functional_ssl.py

test-servers:  ## Run tests for FTPServer and its subclasses.
	${MAKE} install
	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_servers.py

test-authorizers:  ## Run tests for authorizers.
	${MAKE} install
	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_authorizers.py

test-filesystems:  ## Run filesystem tests.
	${MAKE} install
	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_filesystems.py

test-ioloop:  ## Run IOLoop tests.
	${MAKE} install
	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_ioloop.py

test-misc:  ## Run miscellaneous tests.
	${MAKE} install
	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_misc.py

test-by-name:  ## e.g.: make test-by-name ARGS=pyftpdlib.test.test_functional.TestFtpStoreData
	${MAKE} install
	PYTHONWARNINGS=all $(PYTHON) -m unittest -v $(ARGS)

test-coverage:  ## Run test coverage.
	${MAKE} install
	rm -rf .coverage htmlcov
	PYTHONWARNINGS=all $(PYTHON) -m coverage run $(TSCRIPT)
	$(PYTHON) -m coverage report
	@echo "writing results to htmlcov/index.html"
	$(PYTHON) -m coverage html
	$(PYTHON) -m webbrowser -t htmlcov/index.html

pep8:  ## PEP8 linter.
	@git ls-files | grep \\.py$ | xargs $(PYTHON) -m pep8

pyflakes:  ## Pyflakes linter.
	@export PYFLAKES_NODOCTEST=1 && \
		git ls-files | grep \\.py$ | xargs $(PYTHON) -m pyflakes

flake8:  ## flake8 linter.
	@git ls-files | grep \\.py$ | xargs $(PYTHON) -m flake8

check-manifest:  ## Inspect MANIFEST.in file.
	$(PYTHON) -m check_manifest -v $(ARGS)

upload-src:  ## Upload source on PYPI.
	${MAKE} clean
	$(PYTHON) setup.py sdist upload

git-tag-release:  ## Git-tag a new release.
	git tag -a release-`python -c "import setup; print(setup.VERSION)"` -m `git rev-list HEAD --count`:`git rev-parse --short HEAD`
	git push --follow-tags

install-git-hooks:  ## Install GIT pre-commit hook
	ln -sf ../../.git-pre-commit .git/hooks/pre-commit
	chmod +x .git/hooks/pre-commit

grep-todos:  ## Look for TODOs in source files.
	git grep -EIn "TODO|FIXME|XXX"

pre-release:  ## All the necessary steps before making a release.
	${MAKE} clean
	$(PYTHON) -c \
		"from pyftpdlib import __ver__ as ver; \
		doc = open('docs/index.rst').read(); \
		history = open('HISTORY.rst').read(); \
		assert ver in history, '%r not in HISTORY.rst' % ver; \
		assert 'XXXX' not in history; \
		"
	$(PYTHON) setup.py sdist

release:  ## Creates a release (tar.gz + upload + git tag release).
	${MAKE} pre-release
	$(PYTHON) -m twine upload dist/*  # upload tar on PYPI
	${MAKE} git-tag-release

generate-manifest:  ## Generates MANIFEST.in file.
	$(PYTHON) scripts/generate_manifest.py > MANIFEST.in

print-announce:  ## Print announce of new release.
	@$(PYTHON) scripts/print_announce.py

help: ## Display callable targets.
	@grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}'

=== debian/changelog ===
python-pyftpdlib (1.5.4-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.

  [ Sandro Tosi ]
  * Drop python2 support; Closes: #938065

 -- Sandro Tosi <morph@debian.org>  Fri, 13 Dec 2019 13:28:46 -0500

python-pyftpdlib (1.5.4-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces
  * Convert git repository from git-dpm to gbp layout
  * Use 'python3 -m sphinx' instead of sphinx-build for building docs

  [ W. Martin Borgert ]
  * New upstream version

 -- W. Martin Borgert <debacle@debian.org>  Thu, 25 Oct 2018 22:33:42 +0000

=== debian/control ===
--- 
+++ 
@@ -3,40 +3,22 @@
 Priority: optional
 Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
 Uploaders: W. Martin Borgert <debacle@debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 11),
                dh-python,
-               python-all (>= 2.6.6-3~),
                python3-all,
-               python-mock,
                python3-mock,
-               python-openssl,
                python3-openssl,
-               python-sendfile (>= 2.0.0),
+               python3-psutil,
                python3-sendfile (>= 2.0.0),
-               python-setuptools (>= 0.6b3),
                python3-setuptools,
 	       python3-sphinx,
-	       python3-sphinx-rtd-theme
+	       python3-sphinx-rtd-theme,
+               python3-unittest2,
 Standards-Version: 4.1.3
 Rules-Requires-Root: no
 Homepage: https://github.com/giampaolo/pyftpdlib/
 Vcs-Git: https://salsa.debian.org/python-team/modules/python-pyftpdlib.git
 Vcs-Browser: https://salsa.debian.org/python-team/modules/python-pyftpdlib
-
-Package: python-pyftpdlib
-Architecture: all
-Depends: ${misc:Depends}, ${python:Depends}
-Recommends: python-sendfile (>= 2.0.0)
-Provides: ${python:Provides}
-Description: Python FTP server library (Python 2)
- Python FTP server library provides a high-level portable interface to
- easily write asynchronous FTP servers with Python.
- .
- pyftpdlib is currently the most complete RFC-959 FTP server
- implementation available for Python programming language. It is used
- in projects like Google Chromium and Bazaar.
- .
- This package provides the Python 2.x module.
 
 Package: python3-pyftpdlib
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=pyftpdlib

%:
	dh $@ --with python3,sphinxdoc --buildsystem=pybuild

override_dh_auto_test:
ifeq "$(filter nocheck,$(DEB_BUILD_OPTIONS))" ""
	EXCLUDETESTS="test_functional.py test_functional_ssl.py" \
	PYTHONPATH=. TRAVIS=1 python3 pyftpdlib/test/runner.py
endif

override_dh_python3:
	dh_python3 -O--buildsystem=pybuild
	rm -f ./debian/python3-pyftpdlib/usr/bin/ftpbench
	rm -rf ./debian/python3-pyftpdlib/usr/lib/python3/dist-packages/pyftpdlib/test/

override_dh_auto_build:
	dh_auto_build
	( cd docs; \
	  PYTHONPATH=. http_proxy='127.0.0.1:9' python3 -m sphinx -M html . _build )

=== debian/watch ===
version=3
https://github.com/giampaolo/pyftpdlib/releases \
.*[^n]/(?:|v|version-|release-|r|REL_|rel-|(?:python-pyftpdlib|pyftpdlib)(?:_|-))(\d[^\s/]*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## python-pyftpdlib 1.5.7

=== Makefile ===
--- 
+++ 
@@ -2,20 +2,25 @@
 # To use a specific Python version run:
 # $ make install PYTHON=python3.3
 
-PYTHON = python
+PYTHON = python3
 TSCRIPT = pyftpdlib/test/runner.py
 ARGS =
 DEV_DEPS = \
+	git+https://github.com/PyCQA/autoflake.git \
+	cffi \
 	check-manifest \
 	coverage \
 	flake8 \
+	flake8-blind-except \
+	flake8-bugbear \
+	flake8-debugger \
+	flake8-print \
+	flake8-quotes \
+	isort \
 	mock==1.0.1 \
-	pep8 \
-	pyflakes \
 	setuptools \
 	sphinx
 TEST_DEPS = \
-	nose \
 	psutil \
 	pyopenssl \
 	pysendfile \
@@ -23,6 +28,12 @@
 
 # In not in a virtualenv, add --user options for install commands.
 INSTALL_OPTS = `$(PYTHON) -c "import sys; print('' if hasattr(sys, 'real_prefix') else '--user')"`
+TEST_PREFIX = PYTHONWARNINGS=always
+
+
+# ===================================================================
+# Install
+# ===================================================================
 
 all: test
 
@@ -43,6 +54,7 @@
 		*\$testfile* \
 		.coverage \
 		.tox \
+		pyftpd-tmp-\* \
 		build/ \
 		dist/ \
 		docs/_build/ \
@@ -56,7 +68,7 @@
 
 uninstall:  ## Uninstall this package.
 	cd ..; $(PYTHON) -m pip uninstall -y -v pyftpdlib || true
-	$(PYTHON) scripts/purge_installation.py
+	$(PYTHON) scripts/internal/purge_installation.py
 
 install-pip:  ## (only if necessary)
 	$(PYTHON) -c \
@@ -80,45 +92,49 @@
 setup-dev-env:  ## Install GIT hooks, pip, test deps (also upgrades them).
 	${MAKE} install-git-hooks
 	${MAKE} install-pip
-	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade pip
+	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade pip setuptools
 	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade $(TEST_DEPS)
 	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade $(DEV_DEPS)
 
+# ===================================================================
+# Tests
+# ===================================================================
+
 test:  ## Run all tests.
 	${MAKE} install
-	PYTHONWARNINGS=all $(PYTHON) $(TSCRIPT)
+	$(TEST_PREFIX) $(PYTHON) $(TSCRIPT)
 
 test-functional:  ## Run functional FTP tests.
 	${MAKE} install
-	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_functional.py
+	$(TEST_PREFIX) $(PYTHON) pyftpdlib/test/test_functional.py
 
 test-functional-ssl:  ## Run functional FTPS tests.
 	${MAKE} install
-	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_functional_ssl.py
+	$(TEST_PREFIX) $(PYTHON) pyftpdlib/test/test_functional_ssl.py
 
 test-servers:  ## Run tests for FTPServer and its subclasses.
 	${MAKE} install
-	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_servers.py
+	$(TEST_PREFIX) $(PYTHON) pyftpdlib/test/test_servers.py
 
 test-authorizers:  ## Run tests for authorizers.
 	${MAKE} install
-	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_authorizers.py
+	$(TEST_PREFIX) $(PYTHON) pyftpdlib/test/test_authorizers.py
 
 test-filesystems:  ## Run filesystem tests.
 	${MAKE} install
-	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_filesystems.py
+	$(TEST_PREFIX) $(PYTHON) pyftpdlib/test/test_filesystems.py
 
 test-ioloop:  ## Run IOLoop tests.
 	${MAKE} install
-	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_ioloop.py
+	$(TEST_PREFIX) $(PYTHON) pyftpdlib/test/test_ioloop.py
 
 test-misc:  ## Run miscellaneous tests.
 	${MAKE} install
-	PYTHONWARNINGS=all $(PYTHON) pyftpdlib/test/test_misc.py
+	$(TEST_PREFIX) $(PYTHON) pyftpdlib/test/test_misc.py
 
 test-by-name:  ## e.g.: make test-by-name ARGS=pyftpdlib.test.test_functional.TestFtpStoreData
 	${MAKE} install
-	PYTHONWARNINGS=all $(PYTHON) -m unittest -v $(ARGS)
+	$(TEST_PREFIX) $(PYTHON) -m unittest -v $(ARGS)
 
 test-coverage:  ## Run test coverage.
 	${MAKE} install
@@ -129,15 +145,34 @@
 	$(PYTHON) -m coverage html
 	$(PYTHON) -m webbrowser -t htmlcov/index.html
 
-pep8:  ## PEP8 linter.
-	@git ls-files | grep \\.py$ | xargs $(PYTHON) -m pep8
-
-pyflakes:  ## Pyflakes linter.
-	@export PYFLAKES_NODOCTEST=1 && \
-		git ls-files | grep \\.py$ | xargs $(PYTHON) -m pyflakes
-
-flake8:  ## flake8 linter.
-	@git ls-files | grep \\.py$ | xargs $(PYTHON) -m flake8
+# ===================================================================
+# Linters
+# ===================================================================
+
+flake8:  ## Run flake8 linter.
+	git ls-files '*.py' | xargs $(PYTHON) -m flake8 --config=.flake8
+
+isort:  ## Run isort linter.
+	git ls-files '*.py' | xargs $(PYTHON) -m isort --settings=.isort.cfg --check-only
+
+lint-all:  ## Run all linters
+	${MAKE} flake8
+	${MAKE} isort
+
+fix-flake8:  ## Run autopep8, fix some Python flake8 / pep8 issues.
+	@git ls-files '*.py' | xargs $(PYTHON) -m autopep8 --in-place --jobs 0 --global-config=.flake8
+	@git ls-files '*.py' | xargs $(PYTHON) -m autoflake --in-place --jobs 0 --remove-all-unused-imports --remove-unused-variables --remove-duplicate-keys
+
+fix-isort:  ## Fix imports with isort.
+	git ls-files '*.py' | xargs $(PYTHON) -m isort --settings=.isort.cfg
+
+fix-all:  ## Run all fixers
+	${MAKE} fix-flake8
+	${MAKE} fix-isort
+
+# ===================================================================
+# Distribution
+# ===================================================================
 
 check-manifest:  ## Inspect MANIFEST.in file.
 	$(PYTHON) -m check_manifest -v $(ARGS)
@@ -150,8 +185,8 @@
 	git tag -a release-`python -c "import setup; print(setup.VERSION)"` -m `git rev-list HEAD --count`:`git rev-parse --short HEAD`
 	git push --follow-tags
 
-install-git-hooks:  ## Install GIT pre-commit hook
-	ln -sf ../../.git-pre-commit .git/hooks/pre-commit
+install-git-hooks:  ## Install GIT pre-commit hook.
+	ln -sf ../../scripts/internal/git_pre_commit.py .git/hooks/pre-commit
 	chmod +x .git/hooks/pre-commit
 
 grep-todos:  ## Look for TODOs in source files.
@@ -174,10 +209,10 @@
 	${MAKE} git-tag-release
 
 generate-manifest:  ## Generates MANIFEST.in file.
-	$(PYTHON) scripts/generate_manifest.py > MANIFEST.in
+	$(PYTHON) scripts/internal/generate_manifest.py > MANIFEST.in
 
 print-announce:  ## Print announce of new release.
-	@$(PYTHON) scripts/print_announce.py
+	@$(PYTHON) scripts/internal/print_announce.py
 
 help: ## Display callable targets.
 	@grep -E '^[a-zA-Z_-]+:.*?## .*$$' $(MAKEFILE_LIST) | sort | awk 'BEGIN {FS = ":.*?## "}; {printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}'

=== debian/changelog ===
python-pyftpdlib (1.5.7-3) unstable; urgency=medium

  * Fix debian/watch

 -- Martin <debacle@debian.org>  Mon, 27 Feb 2023 22:13:23 +0000

python-pyftpdlib (1.5.7-2) unstable; urgency=medium

  * Fix dependency for autopkgtest

 -- Martin <debacle@debian.org>  Wed, 02 Nov 2022 10:04:47 +0000

python-pyftpdlib (1.5.7-1) unstable; urgency=medium

  * New upstream version
  * Drop build-depend and recommend on sendfile, we have Python >= 3.3
  * Add autopkgtest
  * Refresh patch
  * Bump debhelper compat to 13

 -- Martin <debacle@debian.org>  Tue, 01 Nov 2022 13:04:21 +0000

python-pyftpdlib (1.5.4-3) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Ondřej Nový ]
  * d/control: Update Maintainer field with new Debian Python Team
    contact address.
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

 -- Sandro Tosi <morph@debian.org>  Fri, 03 Jun 2022 23:25:03 -0400

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: python-pyftpdlib
 Section: python
 Priority: optional
-Maintainer: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
-Uploaders: W. Martin Borgert <debacle@debian.org>
-Build-Depends: debhelper-compat (= 11),
+Maintainer: Debian Python Team <team+python@tracker.debian.org>
+Uploaders: Martin <debacle@debian.org>
+Build-Depends: debhelper-compat (= 13),
                dh-python,
                python3-all,
                python3-mock,
                python3-openssl,
                python3-psutil,
-               python3-sendfile (>= 2.0.0),
                python3-setuptools,
 	       python3-sphinx,
 	       python3-sphinx-rtd-theme,
@@ -17,13 +16,12 @@
 Standards-Version: 4.1.3
 Rules-Requires-Root: no
 Homepage: https://github.com/giampaolo/pyftpdlib/
-Vcs-Git: https://salsa.debian.org/python-team/modules/python-pyftpdlib.git
-Vcs-Browser: https://salsa.debian.org/python-team/modules/python-pyftpdlib
+Vcs-Git: https://salsa.debian.org/python-team/packages/python-pyftpdlib.git
+Vcs-Browser: https://salsa.debian.org/python-team/packages/python-pyftpdlib
 
 Package: python3-pyftpdlib
 Architecture: all
 Depends: ${misc:Depends}, ${python3:Depends}
-Recommends: python3-sendfile (>= 2.0.0)
 Provides: ${python3:Provides}
 Description: Python FTP server library (Python 3)
  Python FTP server library provides a high-level portable interface to

## python-pyftpdlib 1.5.9

=== Makefile ===
--- 
+++ 
@@ -1,34 +1,37 @@
 # Shortcuts for various tasks (UNIX only).
 # To use a specific Python version run:
-# $ make install PYTHON=python3.3
+# $ make install PYTHON=python3.7
 
 PYTHON = python3
 TSCRIPT = pyftpdlib/test/runner.py
 ARGS =
-DEV_DEPS = \
-	git+https://github.com/PyCQA/autoflake.git \
-	cffi \
+PYDEPS = \
 	check-manifest \
 	coverage \
-	flake8 \
-	flake8-blind-except \
-	flake8-bugbear \
-	flake8-debugger \
-	flake8-print \
-	flake8-quotes \
-	isort \
-	mock==1.0.1 \
+	psutil \
+	pylint \
+	pyopenssl \
+	rstcheck \
+	ruff \
 	setuptools \
-	sphinx
-TEST_DEPS = \
-	psutil \
-	pyopenssl \
-	pysendfile \
-	unittest2
+	teyit \
+	toml-sort \
+	twine
+PYVER = $(shell $(PYTHON) -c "import sys; print(sys.version_info[0])")
+ifeq ($(PYVER), 2)
+	PYDEPS = \
+		ipaddress \
+		mock \
+		psutil \
+		pyopenssl \
+		pysendfile \
+		setuptools
+endif
 
 # In not in a virtualenv, add --user options for install commands.
 INSTALL_OPTS = `$(PYTHON) -c "import sys; print('' if hasattr(sys, 'real_prefix') else '--user')"`
 TEST_PREFIX = PYTHONWARNINGS=always
+NUM_WORKERS = `$(PYTHON) -c "import os; print(os.cpu_count() or 1)"`
 
 
 # ===================================================================
@@ -38,7 +41,8 @@
 all: test
 
 clean:  ## Remove all build files.
-	rm -rf `find . -type d -name __pycache__ \
+	@rm -rfv `find . \
+		-type d -name __pycache__ \
 		-o -type f -name \*.bak \
 		-o -type f -name \*.orig \
 		-o -type f -name \*.pyc \
@@ -48,17 +52,19 @@
 		-o -type f -name \*.so \
 		-o -type f -name \*.~ \
 		-o -type f -name \*\$testfn`
-	rm -rf \
+	@rm -rfv \
 		*.core \
 		*.egg-info \
 		*\$testfile* \
 		.coverage \
-		.tox \
-		pyftpd-tmp-\* \
+		.failed-tests.txt \
+		.pytest_cache \
+		.ruff_cache/ \
 		build/ \
 		dist/ \
 		docs/_build/ \
 		htmlcov/ \
+		pyftpd-tmp-* \
 		tmp/
 
 install:  ## Install this package.
@@ -74,7 +80,7 @@
 	$(PYTHON) -c \
 		"import sys, ssl, os, pkgutil, tempfile, atexit; \
 		sys.exit(0) if pkgutil.find_loader('pip') else None; \
-		pyexc = 'from urllib.request import urlopen' if sys.version_info[0] == 3 else 'from urllib2 import urlopen'; \
+		pyexc = 'from urllib.request import urlopen' if sys.version_info[0] >= 3 else 'from urllib2 import urlopen'; \
 		exec(pyexc); \
 		ctx = ssl._create_unverified_context() if hasattr(ssl, '_create_unverified_context') else None; \
 		kw = dict(context=ctx) if ctx else {}; \
@@ -89,20 +95,19 @@
 		f.close(); \
 		sys.exit(code);"
 
-setup-dev-env:  ## Install GIT hooks, pip, test deps (also upgrades them).
+setup-dev-env: ## Install GIT hooks, pip, test deps (also upgrades them).
 	${MAKE} install-git-hooks
 	${MAKE} install-pip
 	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade pip setuptools
-	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade $(TEST_DEPS)
-	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade $(DEV_DEPS)
+	$(PYTHON) -m pip install $(INSTALL_OPTS) --upgrade $(PYDEPS)
 
 # ===================================================================
 # Tests
 # ===================================================================
 
-test:  ## Run all tests.
-	${MAKE} install
-	$(TEST_PREFIX) $(PYTHON) $(TSCRIPT)
+test:  ## Run all tests. To run a specific test: do "make test ARGS=pyftpdlib.test.test_functional.TestFtpStoreData"
+	${MAKE} install
+	$(TEST_PREFIX) $(PYTHON) $(TSCRIPT) $(ARGS)
 
 test-functional:  ## Run functional FTP tests.
 	${MAKE} install
@@ -131,10 +136,6 @@
 test-misc:  ## Run miscellaneous tests.
 	${MAKE} install
 	$(TEST_PREFIX) $(PYTHON) pyftpdlib/test/test_misc.py
-
-test-by-name:  ## e.g.: make test-by-name ARGS=pyftpdlib.test.test_functional.TestFtpStoreData
-	${MAKE} install
-	$(TEST_PREFIX) $(PYTHON) -m unittest -v $(ARGS)
 
 test-coverage:  ## Run test coverage.
 	${MAKE} install
@@ -149,26 +150,40 @@
 # Linters
 # ===================================================================
 
-flake8:  ## Run flake8 linter.
-	git ls-files '*.py' | xargs $(PYTHON) -m flake8 --config=.flake8
-
-isort:  ## Run isort linter.
-	git ls-files '*.py' | xargs $(PYTHON) -m isort --settings=.isort.cfg --check-only
+ruff:  ## Run ruff linter.
+	@git ls-files '*.py' | xargs $(PYTHON) -m ruff check --config=pyproject.toml --no-cache
+
+_pylint:  ## Python pylint (not mandatory, just run it from time to time)
+	@git ls-files '*.py' | xargs $(PYTHON) -m pylint --rcfile=pyproject.toml --jobs=${NUM_WORKERS}
+
+lint-rst:  ## Run RsT linter.
+	@git ls-files '*.rst' | xargs rstcheck --config=pyproject.toml
+
+lint-toml:  ## Linter for pyproject.toml
+	@git ls-files '*.toml' | xargs toml-sort --check
 
 lint-all:  ## Run all linters
-	${MAKE} flake8
-	${MAKE} isort
-
-fix-flake8:  ## Run autopep8, fix some Python flake8 / pep8 issues.
-	@git ls-files '*.py' | xargs $(PYTHON) -m autopep8 --in-place --jobs 0 --global-config=.flake8
-	@git ls-files '*.py' | xargs $(PYTHON) -m autoflake --in-place --jobs 0 --remove-all-unused-imports --remove-unused-variables --remove-duplicate-keys
-
-fix-isort:  ## Fix imports with isort.
-	git ls-files '*.py' | xargs $(PYTHON) -m isort --settings=.isort.cfg
-
-fix-all:  ## Run all fixers
-	${MAKE} fix-flake8
-	${MAKE} fix-isort
+	${MAKE} ruff
+	${MAKE} lint-rst
+	${MAKE} lint-toml
+
+# ===================================================================
+# Fixers
+# ===================================================================
+
+fix-ruff:
+	@git ls-files '*.py' | xargs $(PYTHON) -m ruff --config=pyproject.toml --no-cache --fix
+
+fix-toml:  ## Fix pyproject.toml
+	@git ls-files '*.toml' | xargs toml-sort
+
+fix-unittests:  ## Fix unittest idioms.
+	@git ls-files '*test_*.py' | xargs $(PYTHON) -m teyit --show-stats
+
+fix-all:  ## Run all code fixers.
+	${MAKE} fix-ruff
+	${MAKE} fix-toml
+	${MAKE} fix-unittests
 
 # ===================================================================
 # Distribution
@@ -182,7 +197,7 @@
 	$(PYTHON) setup.py sdist upload
 
 git-tag-release:  ## Git-tag a new release.
-	git tag -a release-`python -c "import setup; print(setup.VERSION)"` -m `git rev-list HEAD --count`:`git rev-parse --short HEAD`
+	git tag -a release-`python3 -c "import setup; print(setup.VERSION)"` -m `git rev-list HEAD --count`:`git rev-parse --short HEAD`
 	git push --follow-tags
 
 install-git-hooks:  ## Install GIT pre-commit hook.
@@ -205,7 +220,7 @@
 
 release:  ## Creates a release (tar.gz + upload + git tag release).
 	${MAKE} pre-release
-	$(PYTHON) -m twine upload dist/*  # upload tar on PYPI
+	$(PYTHON) -m twine upload --verbose dist/*  # upload tar on PYPI
 	${MAKE} git-tag-release
 
 generate-manifest:  ## Generates MANIFEST.in file.

=== debian/changelog ===
python-pyftpdlib (1.5.9-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.5.9
  * add d/gbp.conf matching current Salsa setup
  * new release vendors a copy of old asyncore and asynchat (Closes: #1040092)
  * remove obsolete dependency on python3-unittest2 (Closes: #1058974)
  * refresh patch

 -- Alexandre Detiste <tchet@debian.org>  Tue, 02 Jan 2024 20:49:07 +0100

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,6 @@
                python3-setuptools,
 	       python3-sphinx,
 	       python3-sphinx-rtd-theme,
-               python3-unittest2,
 Standards-Version: 4.1.3
 Rules-Requires-Root: no
 Homepage: https://github.com/giampaolo/pyftpdlib/

=== debian/tests/control ===
Test-Command: EXCLUDETESTS="test_functional.py test_functional_ssl.py" PYTHONPATH=. TRAVIS=1 python3 pyftpdlib/test/runner.py
Depends: @, python3-psutil
Restrictions: allow-stderr
